use microrm::schema::entity::EntityPartList;

use crate::{schema, UIDCError};
use super::Object;

#[derive(clap::Parser, Debug)]
pub struct CreateParameters {
    shortname: String,
}

impl Object for schema::Role {
    type CreateParameters = CreateParameters;

    fn create_from_params(cp: &Self::CreateParameters) -> Result<Self, UIDCError> {
        Ok(Self {
            shortname: cp.shortname.clone(),
            groups: Default::default(),
        })
    }

    fn db_object(db: &schema::UIDCDatabase) -> &microrm::prelude::IDMap<Self> where Self: Sized {
        todo!()
    }

    fn build_uniques(strings: &Vec<String>) -> <Self::Uniques as EntityPartList>::DatumList {
        strings[0].clone()
    }

    fn shortname(&self) -> &str {
        &self.shortname
    }
}
